close all;
clear all;
 
p = 0.05;
d=p*0.0;
nsim = 10000;


[CV_1_252]=xlsread('CV_252');
[CV_1_500]=xlsread('CV_500');
[CV_1_1000]=xlsread('CV_1000');
[CV_1_1500]=xlsread('CV_1500');
[CV_1_2500]=xlsread('CV_2500');


fcperiod = [252 500 1000 1500 2500];
outlier = zeros(1,length(fcperiod));
lbound = zeros(1,length(fcperiod));
rbound = zeros(1,length(fcperiod));
test = zeros(1,length(fcperiod));
dursqsum = NaN(nsim,length(fcperiod));
res = zeros(length(fcperiod),3);

for j=1:length(fcperiod)
    i = 0;
    if p == 0.01
        if j == 1
            CVm = CV_1_252;
        elseif j == 2
            CVm = CV_1_500;
        elseif j == 3
            CVm = CV_1_1000;
        elseif j == 4
            CVm = CV_1_1500;
        elseif j == 5
            CVm = CV_1_2500;
        end
    elseif p == 0.05
        if j == 1
            CVm = CV_5_252;
        elseif j == 2
            CVm = CV_5_500;
        elseif j == 3
            CVm = CV_5_1000;
        elseif j == 4
            CVm = CV_5_1500;
        elseif j == 5
            CVm = CV_5_2500;
        end
    end
    
    lboundv = CVm(1,1);
    rboundv = CVm(length(CVm(:,1)),1);
     
    while test(1,j)<nsim
        i=i+1;   
        n1= ceil(fcperiod(j)/4);
        n2= ceil(fcperiod(j)/4);
        n3= floor(fcperiod(j)/4);
        n4 = fcperiod(j) - sum([n1 n2 n3]);
        viovec=[binornd(1,p-2*d,1,n1) binornd(1,p+d,1,n2) binornd(1,p-d,1,n3) binornd(1,p+2*d,1,n4)];
        viovecsum = sum(viovec);
        if viovecsum <2
            outlier(1,j) = outlier(1,j) + 1;
        elseif viovecsum <lboundv
            lbound(1,j) = lbound(1,j) + 1;
        elseif viovecsum >rboundv
            rbound(1,j) = rbound(1,j) + 1;
        else 
            test(1,j) = test(1,j) + 1;
            r = -1*viovec';
            VaR = zeros(length(r),1);
            I=(r<VaR);
            durres = Duree(I);
            dur = durres.duree;
            dursqsum(test(1,j),j) = sum(dur.^2)+normrnd(0,0.001,1);
            CV01 = CVm(find(CVm(:,1)==viovecsum),2);
            CV05 = CVm(find(CVm(:,1)==viovecsum),3);
            CV10 = CVm(find(CVm(:,1)==viovecsum),4);
            res(j,:) = res(j,:) + [dursqsum(test(1,j),j)>=CV01 dursqsum(test(1,j),j)>=CV05 dursqsum(test(1,j),j)>=CV10];
            
            [j i test(1,j) outlier(1,j)]
        end
    end
    power(j,:) = [sum(res(j,1))/test(1,j) sum(res(j,2))/test(1,j) sum(res(j,3))/test(1,j)];
end
outlier
lbound
rbound
power


